# Pi strip teasing
# correction

from PIL import Image, ImageDraw
import transgeo as tg


class Segment:
    def __init__(self, pt1, pt2):
        self.pt1 = pt1
        self.pt2 = pt2

    def rotation(self, angle, pt):
        pt1 = tg.rotation(self.pt1, angle, pt)
        pt2 = tg.rotation(self.pt2, angle, pt)
        return Segment(pt1, pt2)

    def trace(self, ctx, **kwargs):
        ctx.line([self.pt1, self.pt2], **kwargs)
        pt3 = tg.homothetie(self.pt2, self.pt1, 10)
        pt4 = tg.homothetie(self.pt1, self.pt2, 10)
        ctx.line([self.pt2, pt3], width=70, fill="black")
        ctx.line([pt4, self.pt1], width=70, fill="black")


pi = "31415926535897932384626433832795028841971693993751"
angle_deg = -25
W = H = 800
img = Image.new("RGB", (W, H), "white")
calque = ImageDraw.Draw(img)
marge = 50
decalageH = 50
decalageV = 120

s = Segment((W//2 + decalageH, H//2 + decalageV),
            (W//2 + decalageH, H//2 + decalageV + 165))

s.trace(calque, width=1, fill="black")
#
for i in range(9):
    if i % 2 == 0:
        pt = s.pt1
        s = s.rotation(int(pi[i]) * angle_deg, pt)
    else:
        pt = s.pt2
        s = s.rotation(int(pi[i]) * (-1) * angle_deg, pt)
    s.trace(calque, width=1, fill="black")
#
img.save(f"pi_strip_teasing_{abs(angle_deg)}.jpg")
